package com.example.elbuenopeso.ui.market

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.GridView
import android.widget.ListView
import android.widget.ToggleButton
import androidx.fragment.app.Fragment
import androidx.lifecycle.ViewModelProvider
import com.example.elbuenopeso.databinding.FragmentMarketBinding
import com.example.elbuenopeso.R
import com.example.elbuenopeso.adapters.DbAdapter
import com.example.elbuenopeso.database.DBManager

class MarketFragment : Fragment() {

    private var _binding: FragmentMarketBinding? = null

    // This property is only valid between onCreateView and
    // onDestroyView.
    private val binding get() = _binding!!

    private lateinit var listView: ListView
    private lateinit var gridView: GridView
    private lateinit var toggleButton: ToggleButton
    private lateinit var adapter: DbAdapter

    private var isGridViewEnabled = false

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        val marketViewModel =
            ViewModelProvider(this)[MarketViewModel::class.java]

        _binding = FragmentMarketBinding.inflate(inflater, container, false)
        val root: View = binding.root
        listView = binding.listView
        gridView = binding.gridView
        toggleButton = binding.toggleButton

        val listView: ListView = binding.listView

        toggleButton.setOnCheckedChangeListener { _, isChecked ->
            isGridViewEnabled = isChecked
            updateView()
        }

        val dbManager: DBManager? = DBManager.getDBManager(requireContext())
        dbManager!!.open()
        val cursor = dbManager.fetch()
        adapter = DbAdapter(requireContext(), cursor!!, R.layout.item_listview_ad)
        adapter.notifyDataSetChanged()
        listView.adapter = adapter
        return root
    }

    private fun updateView() {
        if (isGridViewEnabled) {
            listView.visibility = View.GONE
            gridView.visibility = View.VISIBLE
            gridView.adapter = adapter
        } else {
            gridView.visibility = View.GONE
            listView.visibility = View.VISIBLE
            listView.adapter = adapter
        }
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }
}